package geo;

/**
 * Point d'un cercle déplaçable à la souris
 */
public class PointSurCercle extends PointLibre {
/**
 * angle (en radians) correspondant à la position du point sur le cercle c.
 */
	public double a;
/**
 * Support du point mobile.
 */ 
	public Cercle c;

/**
 * Construit un point sur le cercle c à la position correspondante à l'angle a exprimé en radians
 */
	public PointSurCercle (double a, Cercle c) {
		super (c.Ox + c.r * Math.cos (a), c.Oy + c.r * Math.sin (a));
		this.c = c;
		defini = c.defini;
		this.a = a % (Math.PI * 2);
		if (this.a > Math.PI)
			this.a = this.a - 2.0 * Math.PI;
	}

/**
 * Construit un point sur le cercle c à partir de la position (X, Y) dans la fenêtre d'affichage
 */
	public PointSurCercle (int X, int Y, Cercle c, Repere R) {
		super (X, Y, R);
		defini = c.defini;
		this.c = c;
		a = (defini)? calcule (R.x (X), R.y (Y), c) : 0.0;
	}

/**
 * Construit un point sur le cercle c à partir des coordonnées (x, y)
 */
	public PointSurCercle (double x, double y, Cercle c) {
		super (x, y);
		defini = c.defini;
		this.c = c;
		a = (defini)? calcule (x, y, c) : 0.0;
	}

	private double calcule (double x, double y, Cercle c) {
		double dx = x - c.Ox;
		double dy = y - c.Oy;
		if (dx != 0)
			a = Math.atan (dy / dx);
		else {
			a = 0.5 * Math.PI;
			if (dy < 0)
				a = - a;
		}
		if (dx < 0)
			a += Math.PI;
			if (a > Math.PI)
				a -= 2.0 * Math.PI;
		return a;
	}

/**
 * Pour un point en cours de déplacement, met à jour les coordonnées (X, Y) dans la fenêtre
 */
	public void bouge (int X, int Y, Repere R) {
		if (deplace && defini && R.affiche (X, Y)) {
			a = calcule (R.x (X), R.y (Y), c);
			MAJ();
		}
	}

/**
 * Met à jour les coordonnées du point relativement au repère R
 */
	public void MAJ() {
		x = c.Ox + c.r * Math.cos (a);
		y = c.Oy + c.r * Math.sin (a);
	}

}
