package geo;

import java.awt.Graphics;
import java.awt.Font;
import java.util.StringTokenizer;

/**
 * Texte déplaçable à la souris, extension du PointLibre.
 */
public class Texte extends PointLibre {
/** Ce champ précise la fonte utilisée et sa taille */
	public Font fonte = new Font (Font.SANS_SERIF, Font.PLAIN, 12);
/** Hauteur en points "écran" d'une ligne de texte. */
	public int hauteurLigne = 12;

/** Construit un texte à l'emplacement (X, Y) de la fenêtre et relié au repère R */
	public Texte (int X, int Y, Repere R) {
		super (X, Y, R);
	}

/**
 * Construit un texte à l'emplacement (x, y)
 */
	public Texte (double x, double y) {
		super (x, y);
	}

	private void ds (String nom, Graphics g, int X, int Y) {
		StringTokenizer stnom = new StringTokenizer (nom, "\\");
		while (stnom.hasMoreTokens()) {
			g.drawString (stnom.nextToken(), X, Y);
			Y += hauteurLigne;
		}
	}

/**
 * Trace le texte et le point permettant de déplacer ce texte
 *
 * @param nom le texte&nbsp;;on utilise \\ pour passer à la ligne
 * @param R repère associé
 * @param g support graphique
 */
	public void trace (String nom, Repere R, Graphics g) {
		int X = R.X (x);
		int Y = R.Y (y);
		g.fillRect (X - 1, Y - 1, 3, 3);
		if (nom != null && nom.length() != 0)
			ds (nom, g, X + 3, Y - 3);
	}

/** 
 * Trace le texte uniquement
 *
 * @param nom le texte
 * @param R repère associé
 * @param g support graphique
 */
	public void traceNom (String nom, Repere R, Graphics g) {
		int X = R.X (x);
		int Y = R.Y (y);
		if (nom != null && nom.length() != 0)
			ds (nom, g, X + 3, Y - 3);
	}

/** toString */
	public String toString() {
		return "Texte : fonte " + fonte.toString() + " hauteurLigne = " + hauteurLigne
				+ " emplacement (" + x + ", " + y + ") defini = " + defini; 
	}

}
