package geo;

import java.awt.Graphics;

/**
 * Triangle défini comme un polygone de taille 3
 */
public class Triangle extends Polygone {

/** Construit un triangle non défini. */
	public Triangle () {
		super();
	}

/**
 * Construit le triangle ABC
 *
 * @param A point du triangle
 * @param B point du triangle
 * @param C point du triangle
 */
	public Triangle (Pt A, Pt B, Pt C) {
		super();
		MAJ (A, B, C);
	}

/** Met à jour le triangle ABC
 *
 * @param A point du triangle
 * @param B point du triangle
 * @param C point du triangle
 */
	public void MAJ (Pt A, Pt B, Pt C) {
		defini = A.defini && B.defini && C.defini;
		if (xi == null || xi.length != 3) {
			xi = new double[3];
			yi = new double[3];
		}
		if (defini) {
			xi [0] = A.x;
			yi [0] = A.y;
			xi [1] = B.x;
			yi [1] = B.y;
			xi [2] = C.x;
			yi [2] = C.y;
		}
	}

/** toString */
	public String toString() {
		String s = "Triangle : ";
		for (int i = 0; i < 3; i++)
			s += " (" + xi[i] + ", " + yi[i] + ")";
		s += " defini = " + defini;
		return s;
	}

}
